import re,string
import os,sys

class detection_catalog:
    
    """Reads in the apsis catalogs and stores the information"""
    
    def __init__(self, catalog, verb=None):

        if verb:
            print >>sys.stderr, "\r Initializing class "
        
        # Set up the standard apsis output file names
        self.verb     = verb
        self.catalog  = catalog

        self._SEx_head()
        self._read_detection()
        
        return


    def _SEx_head(self):

        if self.verb:
            print >>sys.stderr, "\r Parsing SEx head for:",self.catalog
            
        
        self.SExcols = {}
        
        # Read the detection catalog
        self.catstr  =  open(self.catalog).readlines()

        for line in self.catstr:
            
            if line[0] <> '#':
                break

            if line[:2] == "##":
                continue

            try:
                line = line.strip()
                vals = line.split()
                col  = vals[1]
                key  = vals[2]
                self.SExcols[key] = int(col) - 1
                print "# %-20s %s" % (key,self.SExcols[key]+1)
            except:
                continue

#         # Go trough the file
#         i = 0
#         #while self.catstr[i][:2] == "# ":
#         while self.catstr[i][0] == "#":
#
#             if self.catstr[i][:2] == "##":
#                 i = i + 1
#                 continue
#            
#             line = self.catstr[i].strip()
#             vals = line.split()
#             col  = vals[1]
#             key  = vals[2]
#             self.SExcols[key] = int(col) - 1
#
#             print "# %-20s %s" % (key,self.SExcols[key]+1)
#
#             i = i + 1
        return

    
    
    def _read_detection(self):
        
        if self.verb:
            print >>sys.stderr, "\r Reading:",self.catalog
	    
        self.X_IMAGE = {}
        self.Y_IMAGE = {}
        self.A_IMAGE = {}
        self.B_IMAGE = {}
        self.KRON_RADIUS = {}
        self.THETA = {}
        self.RADIUS = {}
        self.SIZE = {}
        self.BACK = {}
        self.THRESH = {}
        self.FLAG = {}
        self.RMS = {}
        self.CLASS_STAR = {}
        
        for line in self.catstr:
            
            vals = line.split()
            
            if vals[0][0] == "#":
                continue
            
            ID = str(vals[0])

            self.KRON_RADIUS[ID] = float(vals[self.SExcols['KRON_RADIUS']])
            self.X_IMAGE[ID]     = float(vals[self.SExcols['X_IMAGE']])
            self.Y_IMAGE[ID]     = float(vals[self.SExcols['Y_IMAGE']])

            self.A_IMAGE[ID]     = float(vals[self.SExcols['A_IMAGE']])*self.KRON_RADIUS[ID]
            self.B_IMAGE[ID]     = float(vals[self.SExcols['B_IMAGE']])*self.KRON_RADIUS[ID]
            self.THETA[ID]       = float(vals[self.SExcols['THETA_IMAGE']])

            self.RADIUS[ID]      = 1.5*(self.A_IMAGE[ID])
            self.SIZE[ID]        = int(2*self.RADIUS[ID])

            self.BACK[ID]        = float(vals[self.SExcols['BACKGROUND']])
            self.THRESH[ID]      = float(vals[self.SExcols['THRESHOLD']])
            self.FLAG[ID]        = int  (vals[self.SExcols['FLAGS']])
            self.RMS[ID]         = self.THRESH[ID]/1.5
            self.CLASS_STAR[ID]  = float(vals[self.SExcols['CLASS_STAR']])

            
        return

    
